<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
		xmlns:r="http://xmlresume.sourceforge.net/resume/0.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:office="http://openoffice.org/2000/office" 
		xmlns:style="http://openoffice.org/2000/style" 
		xmlns:text="http://openoffice.org/2000/text" 
		xmlns:table="http://openoffice.org/2000/table" 
		xmlns:draw="http://openoffice.org/2000/drawing" 
		xmlns:fo="http://www.w3.org/1999/XSL/Format" 
		xmlns:xlink="http://www.w3.org/1999/xlink" 
		xmlns:number="http://openoffice.org/2000/datastyle" 
		xmlns:svg="http://www.w3.org/2000/svg" 
		xmlns:chart="http://openoffice.org/2000/chart" 
		xmlns:dr3d="http://openoffice.org/2000/dr3d" 
		xmlns:math="http://www.w3.org/1998/Math/MathML" 
		xmlns:form="http://openoffice.org/2000/form" 
		xmlns:script="http://openoffice.org/2000/script">

  <xsl:strip-space elements="*"/>
  <xsl:include href="../params.xsl"/>
  <xsl:include href="../lib/common.xsl"/>
  <xsl:include href="../lib/string.xsl"/>

  <xsl:param name="META">false</xsl:param>

  <xsl:template name="Heading">
    <xsl:param name="Text">HEADING NOT DEFINED</xsl:param>
    <text:h text:level="2">
      <xsl:copy-of select="$Text"/>
    </text:h>
    <text:p/>
  </xsl:template>

  <xsl:template match="/">
    <xsl:choose>
      <xsl:when test="$META != 'true'">
	<office:document-content
	 xmlns:office="http://openoffice.org/2000/office" 
	 xmlns:style="http://openoffice.org/2000/style" 
	 xmlns:text="http://openoffice.org/2000/text" 
	 xmlns:table="http://openoffice.org/2000/table" 
	 xmlns:draw="http://openoffice.org/2000/drawing" 
	 xmlns:fo="http://www.w3.org/1999/XSL/Format" 
	 xmlns:xlink="http://www.w3.org/1999/xlink" 
	 xmlns:number="http://openoffice.org/2000/datastyle" 
	 xmlns:svg="http://www.w3.org/2000/svg" 
	 xmlns:chart="http://openoffice.org/2000/chart" 
	 xmlns:dr3d="http://openoffice.org/2000/dr3d" 
	 xmlns:math="http://www.w3.org/1998/Math/MathML" 
	 xmlns:form="http://openoffice.org/2000/form" 
	 xmlns:script="http://openoffice.org/2000/script"
	 office:class="text" 
	 office:version="1.0">
	  
	  <office:script/>
	  
	  <office:font-decls/>
	  
	  <office:automatic-styles>
	  </office:automatic-styles>
	  
	  <office:body>
	    <xsl:apply-templates/>
	  </office:body>
	  
	</office:document-content>
      </xsl:when>
      <xsl:otherwise>
	<office:document-meta
	 xmlns:office="http://openoffice.org/2000/office"
	 xmlns:xlink="http://www.w3.org/1999/xlink"
	 xmlns:dc="http://purl.org/dc/elements/1.1/"
	 xmlns:meta="http://openoffice.org/2000/meta"
	 office:version="1.0">
	  <office:meta>
	    <meta:generator>xsltproc (xml-resume-library)</meta:generator>
	    <dc:title>
	      <xsl:apply-templates select="r:resume/r:header/r:name"/>
	      <xsl:text> - </xsl:text>
	      <xsl:value-of select="$resume.word"/> 
	    </dc:title>
	    <dc:subject><xsl:value-of select="$resume.word"/></dc:subject>
	    <dc:language><xsl:value-of select="$lang"/></dc:language>
	    <meta:initial-creator>
	      <xsl:apply-templates select="r:resume/r:header/r:name"/>
	    </meta:initial-creator>
	    <xsl:apply-templates select="r:resume/r:keywords" mode="meta"/>
	  </office:meta>
	</office:document-meta>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="r:keywords"/>

  <xsl:template match="r:keywords" mode="meta">
    <meta:keywords xmlns:meta="http://openoffice.org/2000/meta">
      <meta:keyword>
        <xsl:apply-templates select="r:keyword"/>
      </meta:keyword>
    </meta:keywords>
  </xsl:template>

  <xsl:template match="r:keyword">
    <xsl:apply-templates/>
        <xsl:if test="position() != last()">
      <xsl:text>, </xsl:text>
    </xsl:if>
  </xsl:template>


  <xsl:template match="r:header" mode="standard">
    <text:h text:level="1">
      <xsl:apply-templates select="r:name"/>
    </text:h>
    <text:p />
    <!--
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">Contact Information</xsl:with-param>
    </xsl:call-template>
    -->
    <xsl:if test="r:address">
      <text:p text:style-name="Contact">
        <text:span text:style-name="Contact Title">
        </text:span>
        <text:tab-stop/>
        <xsl:apply-templates select="r:address"/>
      </text:p>
    </xsl:if>
    <xsl:apply-templates select="r:contact"/>
  </xsl:template>

  <xsl:template match="r:header" mode="centered">
    <text:h text:level="1" text:style-name="Heading 1 Centered">
      <xsl:apply-templates select="r:name"/>
    </text:h>
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">Contact Information</xsl:with-param>
    </xsl:call-template>
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	Address
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <xsl:apply-templates select="r:address"/>
    </text:p>
    <xsl:apply-templates select="r:contact"/>
  </xsl:template>

  <!--Contact Information-->
  <xsl:template match="r:contact">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="r:contact/r:phone">
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	<xsl:call-template name="PhoneLocation">
	  <xsl:with-param name="Location" select="@location"/>
	</xsl:call-template>
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <xsl:apply-templates/>
    </text:p>
  </xsl:template>

  <xsl:template match="r:contact/r:fax">
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	<xsl:call-template name="FaxLocation">
	  <xsl:with-param name="Location" select="@location"/>
	</xsl:call-template>
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <xsl:apply-templates/>
    </text:p>
  </xsl:template>

  <xsl:template match="r:contact/r:pager">
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	<xsl:value-of select="$pager.word"/>
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <xsl:apply-templates/>
    </text:p>
  </xsl:template>

  <xsl:template match="r:contact/r:email">
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	<xsl:value-of select="$email.word"/>
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <text:a xlink:href="mailto:{.}">
	<xsl:apply-templates/>
      </text:a>
    </text:p>
  </xsl:template>

  <xsl:template match="r:contact/r:url">
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	<xsl:value-of select="$url.word"/>
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <text:a xlink:href="{.}">
	<xsl:apply-templates/>
      </text:a>
    </text:p>
  </xsl:template>

  <xsl:template match="r:contact/r:instantMessage">
    <text:p text:style-name="Contact">
      <text:span text:style-name="Contact Title">
	<xsl:call-template name="IMServiceName">
	  <xsl:with-param name="Service" select="@service"/>
	</xsl:call-template>
	<xsl:text>: </xsl:text>
      </text:span>
      <text:tab-stop/>
      <xsl:apply-templates/>
    </text:p>
  </xsl:template>


  <!-- Address, in various formats -->
  <xsl:template match="r:address" mode="free-form">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="r:address" mode="standard">
    <!-- templates defined in address.xsl for setting standard fields -->
    <xsl:variable name="AdminDivision">
      <xsl:call-template name="AdminDivision"/>
    </xsl:variable>
    <xsl:variable name="CityDivision">
      <xsl:call-template name="CityDivision"/>
    </xsl:variable>
    <xsl:variable name="PostCode">
      <xsl:call-template name="PostCode"/>
    </xsl:variable>
    <xsl:for-each select="r:street">
      <xsl:apply-templates select="."/>
      <xsl:text>, </xsl:text>
    </xsl:for-each>
    <xsl:if test="r:street2">
      <xsl:apply-templates select="r:street2"/>
    </xsl:if>
    <xsl:if test="string-length($CityDivision) &gt; 0">
      <xsl:value-of select="$CityDivision"/>
    </xsl:if>
    <xsl:apply-templates select="r:city"/>
    <xsl:if test="string-length($AdminDivision) &gt; 0">
      <xsl:text>, </xsl:text>
      <xsl:value-of select="$AdminDivision"/>
    </xsl:if>
    <xsl:if test="string-length($PostCode) &gt; 0">
      <xsl:text> </xsl:text>
      <xsl:value-of select="$PostCode"/>
    </xsl:if>
    <xsl:if test="r:country">
      <xsl:text>, </xsl:text>
      <xsl:apply-templates select="r:country"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="r:address" mode="european">
    <!-- templates defined in address.xsl for setting standard fields -->
    <xsl:variable name="AdminDivision">
      <xsl:call-template name="AdminDivision"/>
    </xsl:variable>
    <xsl:variable name="CityDivision">
      <xsl:call-template name="CityDivision"/>
    </xsl:variable>
    <xsl:variable name="PostCode">
      <xsl:call-template name="PostCode"/>
    </xsl:variable>
    <xsl:for-each select="r:street">
      <xsl:apply-templates select="."/>
    </xsl:for-each>
    <xsl:if test="r:street2">
      <xsl:apply-templates select="r:street2"/>
    </xsl:if>
    <xsl:if test="string-length($CityDivision) &gt; 0">
      <xsl:value-of select="$CityDivision"/>
    </xsl:if>
    <xsl:if test="string-length($PostCode) &gt; 0">
      <xsl:value-of select="$PostCode"/>
    </xsl:if>
    <xsl:apply-templates select="r:city"/>
    <xsl:if test="string-length($AdminDivision) &gt; 0">
      <xsl:value-of select="$AdminDivision"/>
    </xsl:if>
    <xsl:if test="r:country">
      <xsl:apply-templates select="r:country"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="r:address" mode="italian">
    <xsl:for-each select="r:street">
      <xsl:apply-templates select="."/>
    </xsl:for-each>
    <xsl:if test="r:street2">
      <xsl:apply-templates select="r:street2"/>
    </xsl:if>
    <xsl:if test="r:postalCode">
      <xsl:apply-templates select="r:postalCode"/>
      <xsl:text> </xsl:text>
    </xsl:if>
    <xsl:apply-templates select="r:city"/>
    <xsl:if test="r:province">
      <xsl:text> (</xsl:text>
      <xsl:apply-templates select="r:province"/>
      <xsl:text>)</xsl:text>
    </xsl:if>
    <xsl:if test="r:country">
      <xsl:apply-templates select="r:country"/>
    </xsl:if>
  </xsl:template>

  <!-- Preserve line breaks within a free format address -->
  <xsl:template match="r:address//text()">
    <xsl:call-template name="String-Replace">
      <xsl:with-param name="Text" select="."/>
      <xsl:with-param name="Search-For">
	<xsl:text>
	</xsl:text>
      </xsl:with-param>
      <xsl:with-param name="Replace-With">
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>


<!-- Objective, with level 2 heading. -->
  <xsl:template match="r:objective">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:value-of select="$objective.word"/>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:apply-templates/>
  </xsl:template>


  <!-- Past jobs, with level 2 heading. -->
  <xsl:template match="r:history">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:value-of select="$history.word"/>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:apply-templates select="r:job"/>
  </xsl:template>

  <!-- Format each job -->
  <xsl:template match="r:job">
    <text:h text:level="3">
      <xsl:apply-templates select="r:jobtitle"/>
      <!--<xsl:text> &#8212; </xsl:text>-->
      <text:tab-stop/>
      <xsl:apply-templates select="r:date|r:period"/>
      <text:line-break/>
      <xsl:apply-templates select="r:employer"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="r:location"/>
    </text:h>
    <xsl:apply-templates select="r:description">
      <xsl:with-param name="css.class">jobDescription</xsl:with-param>
    </xsl:apply-templates>
    <xsl:if test="r:projects/r:project">
      <text:h text:level="4">
	<xsl:value-of select="$projects.word"/>
      </text:h>
      <xsl:apply-templates select="r:projects"/>
    </xsl:if>
    <xsl:if test="r:achievements/r:achievement">
      <text:h text:level="4">
	<xsl:value-of select="$achievements.word"/>
      </text:h>
      <xsl:apply-templates select="r:achievements"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="r:location">
    <xsl:value-of select="$location.start"/>
    <xsl:apply-templates/>
    <xsl:value-of select="$location.end"/>
  </xsl:template>

  <xsl:template match="r:institution">
    <xsl:apply-templates/>
  </xsl:template>

  <!-- Format the projects section as a bullet list -->
  <xsl:template match="r:projects">
    <text:unordered-list text:style-name="Bulleted">
      <xsl:apply-templates select="r:project"/>
    </text:unordered-list>
  </xsl:template>

  <!-- Format a project as a bullet -->
  <xsl:template match="r:project">
    <text:list-item>
      <text:p>
	<xsl:if test="@title">
	  <text:span text:style-name="Project Title">
	    <xsl:value-of select="@title"/>
	    <xsl:value-of select="$title.separator"/>
	  </text:span>
	</xsl:if>
	<xsl:apply-templates/>
      </text:p>
    </text:list-item>
  </xsl:template>

  <xsl:template match="r:jobtitle">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="r:employer">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="r:organization">
    <xsl:apply-templates/>
  </xsl:template>


  <!-- Format the period element -->
  <xsl:template match="r:period">
    <xsl:apply-templates select="r:from"/>
    <xsl:text> &#x2014; </xsl:text>
    <xsl:apply-templates select="r:to"/>
   </xsl:template>

   <!-- Format a date -->
   <xsl:template match="r:date" name="FormatDate">
     <xsl:if test="r:dayOfMonth">
       <xsl:apply-templates select="r:dayOfMonth"/>
       <xsl:text> </xsl:text>
     </xsl:if>
    <xsl:if test="r:month">
      <xsl:apply-templates select="r:month"/>
      <xsl:text> </xsl:text>
    </xsl:if>
    <xsl:apply-templates select="r:year"/>
  </xsl:template>
  <xsl:template match="r:present">
    <xsl:value-of select="$present.word"/>
  </xsl:template>

  <!-- Format the achievements section as a bullet list *SE* -->
  <xsl:template match="r:achievements">
    <text:unordered-list text:style-name="Bulleted">
      <xsl:for-each select="r:achievement">
	<text:list-item>
	  <text:p>
	    <xsl:apply-templates/>
	  </text:p>
	</text:list-item>
      </xsl:for-each>
    </text:unordered-list>
  </xsl:template>


  <!-- Degrees and stuff -->
  <xsl:template match="r:academics">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:value-of select="$academics.word"/>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:apply-templates select="r:degrees"/>
    <xsl:apply-templates select="r:note"/>
  </xsl:template>

  <xsl:template match="r:degrees">
    <xsl:apply-templates select="r:degree"/>
    <xsl:apply-templates select="r:note"/>
  </xsl:template>

  <xsl:template match="r:note">
    <xsl:apply-templates/>
  </xsl:template>

  <!-- Format a degree -->
  <xsl:template match="r:degree">
    <text:h text:level="3">
      <xsl:apply-templates select="r:level"/>
      <xsl:if test="r:major">
	<xsl:text> </xsl:text>
	<xsl:value-of select="$in.word"/>
	<xsl:text> </xsl:text>
	<xsl:apply-templates select="r:major"/>
      </xsl:if>
      <xsl:if test="r:institution">
	<xsl:text> - </xsl:text>
	<xsl:apply-templates select="r:institution"/>
	<xsl:apply-templates select="r:location"/>
      </xsl:if>
      <xsl:if test="r:date|r:period">
	<text:tab-stop/>
	<xsl:apply-templates select="r:date|r:period"/>
      </xsl:if>
    </text:h>
    <xsl:if test="r:minor">
      <text:p>
	<xsl:apply-templates select="r:minor"/>
      </text:p>
    </xsl:if>
    <xsl:if test="r:annotation">
      <text:p>
	<xsl:text>. </xsl:text>
	<xsl:apply-templates select="r:annotation"/>
      </text:p>
    </xsl:if>
    <xsl:apply-templates select="r:gpa"/>
    <xsl:apply-templates select="r:subjects"/>
    <xsl:apply-templates select="r:projects"/>
  </xsl:template>

  <!-- Format a GPA -->
  <xsl:template match="r:gpa">
    <text:p>
      <xsl:choose>
	<xsl:when test="@type = 'major'">
	  <xsl:value-of select="$major-gpa.word"/>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:value-of select="$overall-gpa.word"/>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:text>: </xsl:text>
      <xsl:apply-templates select="r:score"/>
      <xsl:if test="r:possible">
        <xsl:value-of select="$out-of.word"/>
        <xsl:apply-templates select="r:possible"/>
      </xsl:if>
      <xsl:if test="r:note">
        <xsl:text>. </xsl:text>
        <xsl:apply-templates select="r:note"/>
      </xsl:if>
    </text:p>
  </xsl:template>

  <!-- Format the subjects as a table-->
  <xsl:template match="r:subjects" mode="table">
    <text:p text:style-name="Subject Title">
      <xsl:value-of select="$subjects.word"/>
    </text:p>
    <table:table>
      <xsl:for-each select="r:subject">
	<table:table-row>
          <table:table-cell>
	    <text:p>
	      <xsl:apply-templates select="r:title"/>
	    </text:p>
	  </table:table-cell>
          <xsl:if test="$subjects.result.display = 1">
	    <table:table-cell>
	      <text:p>
		<xsl:apply-templates select="r:result"/>
	      </text:p>
	    </table:table-cell>
          </xsl:if>
	</table:table-row>
      </xsl:for-each>
    </table:table>
  </xsl:template>

  <!-- Format the subjects as a list -->
  <xsl:template match="r:subjects" mode="comma">
    <text:p>
      <text:span text:style-name="Subject Title">
	<xsl:call-template name="Title">
	  <xsl:with-param name="Title" select="$subjects.word"/>
	  <xsl:with-param name="Separator" select="$title.separator"/>
	</xsl:call-template>
      </text:span>
      <xsl:apply-templates select="r:subject" mode="comma"/>
      <xsl:value-of select="$subjects.suffix"/>
    </text:p>
  </xsl:template>

  <!-- Format a subject -->
  <xsl:template match="r:subject" mode="comma">
    <xsl:value-of select="normalize-space(r:title)"/>
    <xsl:if test="$subjects.result.display = 1">
      <xsl:if test="r:result">
        <xsl:value-of select="$subjects.result.start"/>
        <xsl:value-of select="normalize-space(r:result)"/>
        <xsl:value-of select="$subjects.result.end"/>
      </xsl:if>
    </xsl:if>
    <xsl:if test="following-sibling::r:subject">
      <xsl:value-of select="$subjects.separator"/>
    </xsl:if>
  </xsl:template>


  <!-- Format the open-ended skills -->
  <xsl:template match="r:skillarea">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:apply-templates select="r:title"/>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:apply-templates select="r:skillset"/>
  </xsl:template>

  <!-- Format a skillset -->
  <xsl:template match="r:skillset">
    <xsl:choose>
      <xsl:when test="$skills.format = 'comma'">
	<text:p text:style-name="Skills">
	  <xsl:if test="r:title">
	    <text:span text:style-name="Skill Title">
	      <xsl:apply-templates select="r:title">
	        <xsl:with-param name="Separator" select="$title.separator"/>
	      </xsl:apply-templates>
	     </text:span>
	  </xsl:if>
	  <xsl:if test="r:skill">
	    <text:tab-stop/>
	    <xsl:apply-templates select="r:skill" mode="comma"/>
	    <xsl:value-of select="$skills.suffix"/>
	  </xsl:if>
	  <!-- The following block should be removed in a future version. -->
          <xsl:if test="r:skills">
	    <xsl:apply-templates select="r:skills" mode="comma"/>
          </xsl:if>
	</text:p>
      </xsl:when>
      <xsl:otherwise>
	<xsl:if test="r:title">
	  <text:h text:level="3">
            <xsl:apply-templates select="r:title"/>
	  </text:h>
	</xsl:if>
        <xsl:if test="r:skill">
          <text:unordered-list text:style-name="Bulleted">
            <xsl:apply-templates select="r:skill" mode="bullet"/>
	  </text:unordered-list>
        </xsl:if>
	<!-- The following block should be removed in a future version. -->
        <xsl:if test="r:skills">
          <text:unordered-list text:style-name="Bulleted">
            <xsl:apply-templates select="r:skills" mode="bullet"/>
	  </text:unordered-list>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- Format a skill as part of a comma-separated list -->
  <xsl:template match="r:skill" mode="comma">
    <xsl:apply-templates/>
    <xsl:apply-templates select="@level"/>
    <xsl:if test="following-sibling::r:skill">
      <xsl:value-of select="$skills.separator"/>
    </xsl:if>
  </xsl:template>

  <!-- Format a skill as part of a bulleted list -->
  <xsl:template match="r:skill" mode="bullet">
    <text:list-item class="skill">
     <text:p>
       <xsl:apply-templates/>
       <xsl:apply-templates select="@level"/>
     </text:p>
    </text:list-item>
  </xsl:template>

  <!-- Format a skill level -->
  <xsl:template match="r:skill/@level">
    <xsl:if test="$skills.level.display = 1">
      <xsl:value-of select="$skills.level.start"/>
      <xsl:value-of select="normalize-space(.)"/>
      <xsl:value-of select="$skills.level.end"/>
    </xsl:if>
  </xsl:template>


  <!-- Format publications -->
  <xsl:template match="r:pubs">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:value-of select="$publications.word"/>
      </xsl:with-param>
    </xsl:call-template>
    <text:unordered-list text:style-name="Bulleted">
      <xsl:apply-templates select="r:pub"/>
    </text:unordered-list>
  </xsl:template>

  <!-- Format a single publication -->
  <xsl:template match="r:pub">
      <text:list-item>
	<text:p>
	  <xsl:call-template name="FormatPub"/>
	</text:p>
      </text:list-item>
  </xsl:template>

  <!-- Memberships, with level 2 heading. -->
  <xsl:template match="r:memberships">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:apply-templates select="r:title"/>
      </xsl:with-param>
    </xsl:call-template>
    <text:unordered-list text:style-name="Bulleted">
      <xsl:apply-templates select="r:membership"/>
    </text:unordered-list>
  </xsl:template>

  <!-- A single membership. -->
  <xsl:template match="r:membership">
    <text:list-item>
      <text:p>
	<xsl:if test="r:title">
	  <xsl:call-template name="Title">
	    <xsl:with-param name="Title" select="r:title"/>
	  </xsl:call-template>
	</xsl:if>
	<xsl:if test="r:organization">
	  <xsl:apply-templates select="r:organization"/>
	  <xsl:apply-templates select="r:location"/>
	</xsl:if>
	<xsl:if test="r:date|r:period">
	  <xsl:apply-templates select="r:date|r:period"/>
	</xsl:if>
	<xsl:apply-templates select="r:description">
	  <xsl:with-param name="css.class">membershipDescription</xsl:with-param>
	</xsl:apply-templates>
      </text:p>
    </text:list-item>
  </xsl:template>


  <!-- Format interests section. -->
  <xsl:template match="r:interests">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:call-template name="Title">
          <xsl:with-param name="Title" select="$interests.word"/>
        </xsl:call-template>
      </xsl:with-param>
    </xsl:call-template>
    <text:unordered-list text:style-name="Bulleted">
      <xsl:apply-templates select="r:interest"/>
    </text:unordered-list>
  </xsl:template>

  <!-- A single interest. -->
  <xsl:template match="r:interest">
    <text:list-item>
      <xsl:choose>
	<xsl:when test="$interest.description.format = 'single-line' and
		  r:description">
	  <text:p>
	    <xsl:apply-templates select="r:title"/>
	    <xsl:text>. </xsl:text>
	    <xsl:apply-templates select="r:description"/>
	  </text:p>
	</xsl:when>
	<xsl:otherwise>
	  <text:p>
	    <xsl:apply-templates select="r:title"/>
	  </text:p>
	  <xsl:apply-templates select="r:description"/>
	</xsl:otherwise>
      </xsl:choose>
    </text:list-item>
  </xsl:template>

  <!-- Format an interest description -->
  <xsl:template match="r:interest/r:description">
    <xsl:call-template name="r:description">
      <xsl:with-param name="paragraph.format"
		      select="$interest.description.format"/>
    </xsl:call-template>
  </xsl:template>


  <!-- Format security clearance section. -->
  <xsl:template match="r:clearances">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:call-template name="Title">
          <xsl:with-param name="Title" select="$security-clearances.word"/>
        </xsl:call-template>
      </xsl:with-param>
    </xsl:call-template>
    <text:unordered-list text:style-name="Bulleted">
      <xsl:apply-templates select="r:clearance"/>
    </text:unordered-list>
  </xsl:template>

  <!-- Format a single security clearance. -->
  <xsl:template match="r:clearance">
    <text:list-item>
      <text:p>
	<xsl:apply-templates select="r:level"/>
	<xsl:if test="r:organization">
	  <xsl:text>, </xsl:text>
	  <xsl:apply-templates select="r:organization"/>
	</xsl:if>
	<xsl:if test="r:date|r:period">
	  <xsl:text>, </xsl:text>
	  <xsl:apply-templates select="r:date|r:period"/>
	</xsl:if>
	<xsl:if test="r:note">
	  <xsl:text>. </xsl:text>
	  <xsl:apply-templates select="r:note"/>
	</xsl:if>
      </text:p>
    </text:list-item>
  </xsl:template>


  <!-- Format awards section. -->
  <xsl:template match="r:awards">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:call-template name="Title">
          <xsl:with-param name="Title" select="$awards.word"/>
        </xsl:call-template>
      </xsl:with-param>
    </xsl:call-template>
    <text:unordered-list text:style-name="Bulleted">
      <xsl:apply-templates select="r:award"/>
    </text:unordered-list>
  </xsl:template>

  <!-- A single award. -->
  <xsl:template match="r:award">
    <text:list-item>
      <text:p>
	<xsl:apply-templates select="r:title"/>
	<xsl:if test="r:organization">
	  <xsl:text>, </xsl:text>
	</xsl:if>
	<xsl:apply-templates select="r:organization"/>
	<xsl:if test="r:date|r:period">
	  <xsl:text>, </xsl:text>
	</xsl:if>
	<xsl:apply-templates select="r:date|r:period"/>
	<xsl:apply-templates select="r:description"/>
      </text:p>
    </text:list-item>
  </xsl:template>


  <!-- Format the misc info -->
  <xsl:template match="r:misc">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:value-of select="$miscellany.word"/>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:apply-templates/>
  </xsl:template>

  <!-- Format the "last modified" date -->
  <xsl:template match="r:lastModified">
    <text:p/>
    <text:p>
      <xsl:value-of select="$last-modified.phrase"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates/>
      <xsl:text>.</xsl:text>
    </text:p>
  </xsl:template>

  <!-- Format the legalese -->
  <xsl:template match="r:copyright">
    <text:p>
      <xsl:value-of select="$copyright.word"/>
      <xsl:text> </xsl:text>
      <xsl:apply-templates select="r:year"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="$by.word"/>
      <xsl:text> </xsl:text>
      <xsl:if test="r:name">
	<xsl:apply-templates select="r:name"/>
      </xsl:if>
      <xsl:if test="not(r:name)">
	<xsl:apply-templates select="/r:resume/r:header/r:name"/>
      </xsl:if>
      <xsl:text>. </xsl:text>
    </text:p>
    <xsl:apply-templates select="r:legalnotice"/>
  </xsl:template>

  <!-- para -> p -->
  <xsl:template match="r:para">
    <text:p>
      <xsl:apply-templates/>
    </text:p>
  </xsl:template>

  <!-- emphasis -> strong -->
  <xsl:template match="r:emphasis">
    <text:span text:style-name="Emphasis">
      <xsl:apply-templates/>
    </text:span>
  </xsl:template>

  <!-- url -> monospace along with href -->
  <xsl:template match="r:url" name="FormatUrl">
    <text:a xlink:href="@href"/>
  </xsl:template>

  <!-- link -> make link from href attribute -->
  <xsl:template match="r:link">
    <text:a xlink:href="@href">
      <xsl:apply-templates/>
    </text:a>
  </xsl:template>
  
  <!-- citation -> cite -->
  <xsl:template match="r:citation">
    <text:span text:style-name="Cite">
      <xsl:apply-templates/>
    </text:span>
  </xsl:template>


  <!-- Format the referees -->
  <xsl:template match="r:referees">
    <xsl:call-template name="Heading">
      <xsl:with-param name="Text">
        <xsl:value-of select="$referees.word"/>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:choose>
      <xsl:when test="$referees.display = 1">
        <xsl:choose>
	  <xsl:when test="$referees.layout = 'compact'">
            <table:table class="referees">
              <xsl:apply-templates select="r:referee" mode="compact"/>
            </table:table>
          </xsl:when>
	  <xsl:otherwise>
	    <xsl:apply-templates select="r:referee" mode="standard"/>
	  </xsl:otherwise>
	</xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <text:p>
	  <xsl:value-of select="$referees.hidden.phrase"/>
	</text:p>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="r:referee" mode="standard">
    <xsl:apply-templates select="r:name"/>
    <xsl:if test="r:title or r:organization">
      <xsl:apply-templates select="r:title"/>
      <xsl:if test="r:title and r:organization">
	<xsl:text>, </xsl:text>
      </xsl:if>
      <xsl:apply-templates select="r:organization"/>
    </xsl:if>
    <xsl:apply-templates select="r:address"/>
    <xsl:apply-templates select="r:contact"/>
  </xsl:template>

  <xsl:template match="r:referee" mode="compact">
    <table:table-row>
      <table:table-cell>
	<text:p>
	  <xsl:apply-templates select="r:name"/>
	  <xsl:if test="r:title or r:organization">
              <xsl:apply-templates select="r:title"/>
              <xsl:if test="r:title and r:organization">
                <xsl:text>, </xsl:text>
              </xsl:if>
              <xsl:apply-templates select="r:organization"/>
          </xsl:if>
	</text:p>
        <xsl:apply-templates select="r:contact"/>
      </table:table-cell>
      <table:table-cell>
	<text:p>
	  <xsl:apply-templates select="r:address"/>
	</text:p>
      </table:table-cell>
    </table:table-row>
  </xsl:template>


  <!-- Format a description as either a block (div) or a single line (span) -->
  <xsl:template match="r:description" name="r:description">
    <!-- Possible values: 'block', 'single-line' -->
    <xsl:param name="paragraph.format">block</xsl:param>
    <xsl:choose>
      <xsl:when test="$paragraph.format = 'single-line'">
	<xsl:for-each select="r:para">
	  <xsl:apply-templates/>
	  <xsl:if test="following-sibling::*">
	    <xsl:value-of select="$description.para.separator"/>
	  </xsl:if>
	</xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
	<!-- block -->
	<xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
</xsl:stylesheet>
